# -*- coding: utf-8 -*-
from model import WorldInput
import numpy as np

class PhysicsEngine(WorldInput):
    
    grav_constant = 6.67384e-11
    
    def distance(self, pos1, pos2):
        return np.linalg.norm(pos2 - pos1)
    
    def grav_force(self, pos1, pos2, mass1, mass2):
        distance = self.distance(pos1, pos2)
        force_mag = self.grav_constant * mass1 * mass2 / distance**2
        dist_norm = (pos2 - pos1) / distance
        force = dist_norm * force_mag
        return force