# -*- coding: utf-8 -*-
from physics import PhysicsEngine
from skyfield.api import load
#import numpy as np
import datetime
#from file_model import FileSphere

class PhysicsEngineSkyfield(PhysicsEngine):
    
    dt = 0
    planets = None
    timescale = None

    def __init__(self, world, dt):
        super(PhysicsEngineSkyfield, self).__init__(world)
        self.planets = load('de421.bsp')
        self.timescale = load.timescale()
        
        #world.world_objects['sun'] = FileSphere(mass=1.9884e+30,radius=696342000)
        #world.world_objects['mercury barycenter'] = FileSphere(mass=3.301e+23,radius=2439700)
        #world.world_objects['venus barycenter'] = FileSphere(mass=4.867e+24,radius=6018000)
        #world.world_objects['earth barycenter'] = FileSphere(mass=6.046e+24,radius=6350000)
        #world.world_objects['mars barycenter'] = FileSphere(mass=6.417e+23,radius=3396200)
        #world.world_objects['jupiter barycenter'] = FileSphere(mass=1.899e+27,radius=142984000)
        #world.world_objects['saturn barycenter'] = FileSphere(mass=5.685e+26,radius=60268000)
        #world.world_objects['uranus barycenter'] = FileSphere(mass=8.682e+25,radius=25559000)
        #world.world_objects['neptune barycenter'] = FileSphere(mass=1.024e+26,radius=24764000)
        
        #self.step()
        self.dt = dt
            
    def step(self):
        self.world.time += self.dt
        pydt = datetime.datetime(2000, 1, 1, tzinfo=datetime.timezone.utc) + datetime.timedelta(seconds=self.world.time)
        t = self.timescale.utc(pydt)
        
        for key, wo in self.world.world_objects.items():
            planet = self.planets[key]
        
            pos = planet.at(t).ecliptic_xyz().km
            vel = planet.at(t).ecliptic_velocity().km_per_s
            
            wo.position = pos * 1000 # convert to m
            wo.velocity = vel * 1000 # convert to m/s